require 'ext/string'
require 'velcro/version'
require 'velcro/errors'
require 'velcro/system'

# Velcro Lib
module Velcro
  include Velcro::System
  include Velcro::Error

  autoload :Config,     'velcro/config'
  autoload :Symlinker,  'velcro/symlinker'
  autoload :Scaffold,   'velcro/scaffold'
  autoload :Strap,      'velcro/strap'

  # Installer Classes
  module Installer
    autoload :Base,  'velcro/installer/base'
    autoload :Mac,   'velcro/installer/mac'
    autoload :Linux, 'velcro/installer/linux'
  end

  # Setter Classes
  module Setter
    autoload :Base,  'velcro/setter/base'
    autoload :Mac,   'velcro/setter/mac'
    autoload :Linux, 'velcro/setter/linux'
  end

  # Status Classes
  module Status
    autoload :Machine,  'velcro/status/machine'
    autoload :Dotfiles, 'velcro/status/dotfiles'
    autoload :Git,      'velcro/status/git'
    autoload :Ruby,     'velcro/status/ruby'
    autoload :Symlinks, 'velcro/status/symlinks'
  end

  def self.config
    Velcro::Config.instance
  end
end
