require 'json'
module Velcro
  module Installer
    # OSX Specific installations
    class Mac < Installer::Base
      private

      def brew
        `ruby -e "$(curl -fsSL https://raw.githubusercontent.com/Homebrew/install/master/install)"`
        `brew install caskroom/cask/brew-cask`
        `brew tap phinze/homebrew-cask`
        `brew install brew-cask`
        `brew tap caskroom/versions`
        `brew tap caskroom/fonts`
      end

      def brew_install(target)
        puts 'Formula found via brew'
        `brew install #{target}`
      end

      def cask_install(target)
        puts 'Formula found via cask'
        `brew cask install --appdir=/Applications #{target}`
      end

      def brew?(name)
        begin
          JSON.parse `brew info #{name} --json=v1`
        rescue JSON::ParserError
          return false
        end
        true
      end

      def cask?(name)
        `brew cask info #{name}`.match(/No available Cask/).nil?
      end
    end
  end
end
