require 'json'

module Velcro
  module Setter
    # Class that handles setting OSX settings
    class Mac < Setter::Base
      private

      def git(*args)
        super(*args)

        options = args.first || {}
        return unless options['editor']

        command = "git config --global core.editor \"#{options['editor']}\""
        dryrun ? puts(command) : system(command)
      end

      def keyboard_repeat(*args)
        speed = args.first || 0
        command = "defaults write NSGlobalDomain KeyRepeat -int #{speed}"
        dryrun ? puts(command) : system(command)
      end
    end
  end
end
