require 'velcro/concerns/flags'

module Velcro
  module Status
    # Provide information about all systems on the host
    class Machine
      include Velcro::Flags

      FLAGS = %w(git dotfiles symlinks ruby).freeze

      def initialize(options = {})
        establish_inclusions(FLAGS, options)
      end

      def print
        includes.select{|_, v| v }.each_pair do |key, _|
          puts unless key == includes.keys.first
          "Velcro::Status::#{key.capitalize}".constantize.print
        end
      end
    end
  end
end
