module Velcro
  module Status
    # Provide information about the ruby installation
    class Ruby
      def self.print
        printf '## RVM - '
        if !installed?
          puts 'Not Installed'
        elsif rubies.empty?
          puts "Installed\n  No Rubies Installed"
        else
          puts 'Installed'
          rubies.each{|r| puts r }
        end
      end

      def self.installed?
        (`which rvm` =~ /not found/).nil?
      end

      def self.rubies
        `rvm list`.split("\n").select{|str| str =~ /ruby-/}
      end
    end
  end
end
