module Velcro
  # Host machine helper for the Velcro class
  module System
    def self.included(base)
      base.send(:extend,  self::ClassMethods)
    end

    # Class methods for Velcro
    module ClassMethods
      def osx?
        uname == 'Darwin'
      end

      def linux?
        uname == 'Linux'
      end

      def home
        ENV['HOME']
      end

      def ls(dir)
        `ls -al #{dir}`.split("\n")
      end

      def uname
        `uname`.rstrip
      end

      def hostname
        `hostname`.rstrip
      end
    end
  end
end
